diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
index f4fc52261..223cb68d3 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
@@ -1,21 +1,23 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
+    public ItemStack inItem;
+    public RecipeSymbol repairMaterial;
 
-    public RecipeEntryRepairable(Item inItem, Item repairMaterial)
+
+    public RecipeEntryRepairable(ItemStack inItem, RecipeSymbol repairMaterial)
     {
         this.inItem = inItem;
         this.repairMaterial = repairMaterial;
-        inItemStack = new ItemStack(inItem);
     }
 
     @Override
-    public boolean matches(InventoryCrafting inventorycrafting)
+    public boolean matches(CraftingContainer inventorycrafting)
     {
         int repairMaterialCount = 0;
         int inItemCount = 0;
@@ -26,11 +28,11 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
             {
                 ItemStack stack = inventorycrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
-                if (stack.itemID == repairMaterial.id)
+                if (repairMaterial.matches(stack))
                 {
                     repairMaterialCount++;
                 }
-                else if (stack.itemID == inItem.id)
+                else if (inItem.itemID == stack.itemID)
                 {
                     inItemCount++;
                 }
@@ -49,9 +51,8 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
     public boolean matchesQuery(SearchQuery query) {
         return false;
     }
-
     @Override
-    public ItemStack getCraftingResult(InventoryCrafting inventorycrafting)
+    public ItemStack getCraftingResult(CraftingContainer inventorycrafting)
     {
         int repairMaterialCount = 0;
         ItemStack inItemStack = null;
@@ -62,17 +63,19 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
             {
                 ItemStack stack = inventorycrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
-                if (stack.itemID == repairMaterial.id)
+                if (repairMaterial.matches(stack))
                 {
                     repairMaterialCount++;
                 }
-                else if (stack.itemID == inItem.id)
+                else if (inItem.itemID == stack.itemID)
                 {
                     inItemStack = stack.copy();
                 }
             }
         }
 
+        assert inItemStack != null;
+
         for (int i = 0; i < repairMaterialCount; i++)
         {
             if (inItemStack.getMetadata() <= inItemStack.getMaxDamage())
@@ -86,8 +89,9 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
 
         return inItemStack;
     }
+
     @Override
-    public ItemStack[] onCraftResult(InventoryCrafting inventorycrafting){
+    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting){
         ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++)
         {
@@ -110,8 +114,4 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
     public int getRecipeSize() {
         return 2;
     }
-
-    public Item inItem;
-    public Item repairMaterial;
-    public ItemStack inItemStack;
 }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java
index 08495834c..e7e02ccae 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java
@@ -3,7 +3,7 @@ package net.minecraft.core.data.registry.recipe.entry;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     public RecipeEntryRepairableStackable(Item inItem, ItemStack materialStack)
@@ -15,7 +15,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public boolean matches(InventoryCrafting inventorycrafting)
+    public boolean matches(CraftingContainer inventorycrafting)
     {
         int materialStackCount = 0;
         int inItemCount = 0;
@@ -51,7 +51,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public ItemStack getCraftingResult(InventoryCrafting inventorycrafting)
+    public ItemStack getCraftingResult(CraftingContainer inventorycrafting)
     {
         ItemStack inItemStack = null;
         totalStackCount = 0;
@@ -87,7 +87,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public ItemStack[] onCraftResult(InventoryCrafting inventorycrafting){
+    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting){
         int repairCost =  originalDamage - inItemStack.getMetadata();
         ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++)
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java
index 5c423d9bc..c63678393 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java
@@ -3,9 +3,13 @@ package net.minecraft.core.data.registry.recipe.entry;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
+    public Item itemToScrap;
+    public Item scrapYield;
+    public ItemStack scrapYieldStack;
+
 
     public RecipeEntryScrap(Item itemToScrap, Item scrapYield)
     {
@@ -15,7 +19,7 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
     }
 
     @Override
-    public boolean matches(InventoryCrafting inventorycrafting)
+    public boolean matches(CraftingContainer inventorycrafting)
     {
         int itemToScrapCount = 0;
         for (int x = 0; x < 3; x++)
@@ -44,7 +48,7 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
     }
 
     @Override
-    public ItemStack getCraftingResult(InventoryCrafting inventorycrafting)
+    public ItemStack getCraftingResult(CraftingContainer inventorycrafting)
     {
         float itemToScrapDamage = 0;
         float itemMaxDamage = 0;
@@ -70,7 +74,7 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
     }
 
     @Override
-    public ItemStack[] onCraftResult(InventoryCrafting inventorycrafting){
+    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting){
         ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++)
         {
@@ -93,8 +97,4 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
     public int getRecipeSize() {
         return 2;
     }
-
-    public Item itemToScrap;
-    public Item scrapYield;
-    public ItemStack scrapYieldStack;
 }
diff --git a/src/main/java/net/minecraft/core/entity/ConsumedFood.java b/src/main/java/net/minecraft/core/entity/ConsumedFood.java
index b3777b165..c691678fa 100644
--- a/src/main/java/net/minecraft/core/entity/ConsumedFood.java
+++ b/src/main/java/net/minecraft/core/entity/ConsumedFood.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.entity;
 
-import net.minecraft.core.item.ItemFood;
+import net.minecraft.core.item.FoodItem;
 
 public class ConsumedFood {
-    private final EntityLiving entity;
-    private final ItemFood food;
+    private final Mob entity;
+    private final FoodItem food;
     private int healRemaining;
     private int tickCounter = 0;
 
-    public ConsumedFood(EntityLiving entity, ItemFood food) {
+    public ConsumedFood(Mob entity, FoodItem food) {
         this.entity = entity;
         this.food = food;
 
